-- File automatically generated by HDL Generator
-- http://arch.icte.uowm.gr
-- Date: 2016-02-10 21:33
-- Author: Minas Dasygenis (c) 2013-2016

--- function parse_and_create_VHDL_description_for_components()
library IEEE;
library IEEE;
use IEEE.std_logic_1164.all;


entity dffs1rbit is
 port ( d : in std_logic;
 clk : in std_logic;
 rst : in std_logic;
 q : out std_logic);
 end dffs1rbit;

architecture structural of dffs1rbit is

 component dffb1srbit is
 port ( d : in std_logic;
 clk : in std_logic;
 rst : in std_logic;
 setval : in std_logic;
 q : out std_logic;
 q_n : out std_logic);
 end component;

 begin
 mapping: dffb1srbit port map(d=>d,clk=>clk,rst=>rst,setval=>'0',q=>q,q_n=>open);
 end structural;

--- end function parse_and_create_VHDL_description_for_components()
library IEEE;
library IEEE;
use IEEE.std_logic_1164.all;

entity inv1bit is
port (
x: in std_logic;
invout: out std_logic
);
end inv1bit;


architecture rtl of inv1bit is
begin
invout <= not x after 1 ps;
end rtl;
--- end function parse_and_create_VHDL_description_for_components()
library IEEE;
library IEEE;
use IEEE.std_logic_1164.all;

entity dff1bit is
port (
d: in std_logic;
clk: in std_logic;
rst: in std_logic;
q: out std_logic
);
end dff1bit;


architecture rtl of dff1bit is
begin
	PROCESS(rst,clk)
	BEGIN
		IF (rst='1') THEN
			q <= '0' after 1 ps ;
		ELSIF (rising_edge(clk) ) THEN          --better than: clk'EVENT and clk='1') THEN
			q <=d after 1 ps;
		END IF;
	END PROCESS;
end rtl;
--- end function parse_and_create_VHDL_description_for_components()
library IEEE;
library IEEE;
use IEEE.std_logic_1164.all;

entity  and1bit2 is
port (
x: in std_logic;
y: in std_logic;
andout: out std_logic
);
end and1bit2;

architecture rtl of and1bit2 is
begin
andout <= x and y after 1 ps;
end rtl;
--- end function parse_and_create_VHDL_description_for_components()
library IEEE;
library IEEE;
use IEEE.std_logic_1164.all;


entity dffb1srbit  is
 port ( d : in std_logic;
 clk : in std_logic;
 rst : in std_logic;
 setval : in std_logic;
 q : out std_logic;
 q_n : out std_logic);
 end dffb1srbit;

 -- D flip flop
 -- Xilinx language template for spartan-3. Uses exactly one flip flop and some buffers, No LUTS

architecture structural of dffb1srbit is
begin

process(rst,setval,clk)
begin
if (rst = '1') then  --Asynchronous clear input
    q   <= '0';
    q_n <= '1';
else
if(setval = '1') then  --Asynchronous set input
  q   <='1';
  q_n <='0';
else
if ( rising_edge(clk) ) then  --or: if (ce=='1' and rising_edge(clk)) if you have a CLOCK ENABLE input
q <= d;
end if;
end if;
end if;
end process;

end structural;


--- end function parse_and_create_VHDL_description_for_components()
library IEEE;
library IEEE;
use IEEE.std_logic_1164.all;

entity  nand1bit3 is
port (
x: in std_logic;
y: in std_logic;
z: in std_logic;
nandout: out std_logic
);
end nand1bit3;

architecture rtl of nand1bit3 is
begin
nandout <= not (x and y and z) after 1 ps ; --we use a minimum time, because simulation is stuck otherwise, only this defintion is nand correct, because NAND does not commute like AND
end rtl;
--- end function parse_and_create_VHDL_description_for_components()
library IEEE;
library IEEE;
use IEEE.std_logic_1164.all;

entity dff2bit is
port (
d0: in std_logic;
d1: in std_logic;
clk: in std_logic;
rst: in std_logic;
q0: out std_logic;
q1: out std_logic
);
end dff2bit;


architecture rtl of dff2bit is
begin
	PROCESS(rst,clk)
	BEGIN
		IF (rst='1') THEN
			q0 <= '0' after 1 ps;
			q1 <= '1' after 1 ps;
		ELSIF (clk'EVENT and clk='1') THEN
			q0 <=d0 after 1 ps;
			q1 <=d1 after 1 ps;
		END IF;
	END PROCESS;
end rtl;
--- end function parse_and_create_VHDL_description_for_components()
library IEEE;
library IEEE;
use IEEE.std_logic_1164.all;

entity  wire1bit is
port (
x: in std_logic;
z: out std_logic
);
end wire1bit;

architecture rtl of wire1bit is
begin
z <= x;
end rtl;
--- end function parse_and_create_VHDL_description_for_components()
library IEEE;
library IEEE;
use IEEE.std_logic_1164.all;


entity dffs1srbit is
 port ( d : in std_logic;
 clk : in std_logic;
 rst : in std_logic;
 setval : in std_logic;
 q : out std_logic;
 q_n : out std_logic);
 end dffs1srbit;

 -- 7474 Dual Positive Edge Triggered D Flip Flop
 -- D flip flop

architecture structural of dffs1srbit is

 component nand1bit3 port (
 x : in std_logic;
 y : in std_logic;
 z : in std_logic;
 nandout : out std_logic);
 end component;

 signal y0, y1, y2, y3: std_logic;
 signal y4 : std_logic;
 signal y5 : std_logic;
 signal notrst : std_logic;
 signal notset : std_logic;
 begin
 process (clk)
 begin
 if (rising_edge(clk)) then
 q <= y4 after 1 ps;
 q_n <= y5 after 2 ps;
 notrst <= not rst after 1 ps;
 notset <= not setval after 2 ps;
 end if;
 end process;
 -- NOTE: We are using NOT rst and NOT set (original design has rst/set
 -- NOTE: our circuit want SET=RST=0 in order to work properly
 nand0 : nand1bit3 port map (notset, y1,     y3, y0 );
 nand1 : nand1bit3 port map (clk,    notrst, y0, y1 );
 nand2 : nand1bit3 port map (clk,    y3,     y1, y2 );
 nand3 : nand1bit3 port map (d,      notrst, y2, y3 );
 nand4 : nand1bit3 port map (notset, y1,     y5, y4 );
 nand5 : nand1bit3 port map (notrst, y2,     y4, y5 );
 end structural;


--- end function parse_and_create_VHDL_description_for_components()
library IEEE;
library IEEE;
use IEEE.std_logic_1164.all;

entity dffmasterslave1bit is
port (
d: in std_logic;
clk: in std_logic;
rst: in std_logic;
dout: out std_logic
);
end dffmasterslave1bit;

architecture rtl of dffmasterslave1bit is

component dffs1rbit is
port (
d: in std_logic;
clk: in std_logic;
rst: in std_logic;
q: out std_logic
);
end component;

signal s : std_logic;
signal in_clk, in_clk2 : std_logic;
begin
-- this design uses two inverter clocks, and thus minimized the latency (input to output)
-- also the output is changed on the rising edge, which is more correct than the falling edge
-- the second clock was NOT-NOT clk, which is actually the same clk.
in_clk <= not clk;
u0 : dffs1rbit port map (d,  in_clk, rst, s);
u1 : dffs1rbit port map (s, clk, rst, dout);
end rtl;
--- end function parse_and_create_VHDL_description_for_components()
